Listing 1


#!/bin/sh
#
# Erstellt eine Liste der aktuellen Dateien
# auf dem Server, der als erster Parameter
# angegeben wurde.
# Die restlichen Parameter geben die zu sichernden
# Verzeichnisse an.

usage () {
        echo Fehler: $1
        echo ""
        echo Usage: $0 SERVER [Verzeichnisse]
        exit 1
}

BACKUPSERVER=localhost

if [ $# -eq 0 ]
then
        usage "Kein Server angegeben!"
fi

# Welcher Server?
SERVER=$1
shift

# Falls die Verzeichnisnamen fehlen,
# gilt "/" =

if [ $# -eq 0 ]
then
        set -- /
fi

# evtl. Aufruf der Checkpointskripte
if [ -f ./$SERVER.sh ]
then
	./$SERVER.sh
fi

if [ $SERVER = $BACKUPSERVER ]
then
        find $* -exec ls -ldi {} \;
else
        rsh $SERVER "find $* -exec ls -ldi {} \;"
fi \
| sed  "/^ *[0-9]* d[r-][w-][x-]/d
        s/^/$SERVER:/"

Listing 2

#!/bin/sh
#
# Ermittelt aus zwei Dateilisten die Dateien, die
# neu erzeugt, gendert oder gelscht wurden.

usage () {
        echo Fehler: $1
        echo ""
        echo Usage: $0 Liste1 Liste2
        exit 1
}

if [ $# -ne 2 ]
then
        usage "Zuwenig Dateien angegeben!"
fi

TMP=/tmp/$$.diff

if [ $1 -nt $2 ]
then
        diff $2 $1
else
        diff $1 $2
fi \
| grep "^[<>]" \
| sed 's/\([<>]  *[a-z0-9][a-z0-9]*:\)[^\/]*\//\1\//' \
| sort +1 \
| uniq -f 1 -c > $TMP

# Nun wird die Ausgabe interpretiert

# Taucht die Datei nur in der alten Liste auf, =

# wurde sie gelscht:
sed -n '/      1        < /{
                   s/      1    < //
                   s/ -> .*$//
                   p
                  }
        ' $TMP >> deleted

# Ist sie nur in der neuen Liste, wurde sie neu =

# erstellt:
sed -n '/      1        > /{
                   s/      1    > //
                   s/ -> .*$//
                   p
                  }
        ' $TMP > new

# Befindet sie sich in beiden Listen (uniq findet
# zwei Eintrge), so wurde sie verndert:
sed -n '/      2        [<>] /{
                      s/      2 [<>] //
                      s/ -> .*$//
                      p
                     }
        ' $TMP > changed

rm $TMP
