

!!! Listing 1 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xhtml="http://www.w3.org/1999/xhtml"
                version="1.0">

<xsl:template match="xhtml:b | xhtml:i | xhtml:tt">
   Das Element <xsl:value-of select="name()" /> sollte nicht verwendet 
   werden.
   <xsl:apply-templates />
</xsl:template>

<xsl:template match="text()" />

</xsl:stylesheet>

!!! Listing 2

<xsl:template match="abschnitt">
   <xsl:if test="count(ancestor::abschnitt) >= 3">
      Mehr als drei Abschnitt-Ebenen sind nicht gestattet.
   </xsl:if>
   <xsl:apply-templates />
</xsl:template>

!!! Listing 3

<schema xmlns="http://www.ascc.net/xml/schematron"> 
   <title>Artikel-Schema</title>
   <pattern name="Regeln fr Abschnitte">
      <rule context="abschnitt">
         <report test="count(ancestor::abschnitt) >= 3">
            Mehr als drei Abschnitt-Ebenen sind nicht gestattet.
         </report>
         <assert test="normalize-space(.)!=''">
            Ein Abschnitt muss immer Text enthalten.
         </assert>
      </rule>
   </pattern>
</schema>

!!! Listing 4

saxon patterns.sch schematron-report.xsl > patterns.xsl
saxon testfile.xml patterns.xsl > schematron-errors.html
saxon testfile.xml verbid.xsl > schematron-out.html
